--[[
	known colors
	BlueRadiationFog.m2
	RedRadiationFog.m2
	OrangeRadiationFog.m2
	GreenRadiationFog.m2
	BlackRadiationFog.m2
	WhitenRadiationFog.m2
]]

local Fog = 'SPELLS\\BlueRadiationFog.m2'

-- AuctionBar BG
ActionBarFogBGFrame = CreateFrame('Frame', 'ActionBarFogBGFrame', UIParent)
ActionBarFogBGFrame:SetFrameStrata'BACKGROUND'
ActionBarFogBGFrame:SetWidth(606)
ActionBarFogBGFrame:SetHeight(70)
ActionBarFogBGFrame:SetPoint('BOTTOM',UIParent, 0, 2)
ActionBarFogBGFrame:SetBackdrop({bgFile = 'Interface\\Tooltips\\UI-Tooltip-Background',edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',tile = true, tileSize = 16,edgeSize = 4,insets = { left = 3, right = 3, top = 3, bottom = 3 }})
ActionBarFogBGFrame:SetBackdropColor(0,0,0,.5)
ActionBarFogBGFrame:SetBackdropBorderColor(0,0,0,.5)
-- .SetGradientAlpha('VERTICAL',.1,.1,.1,1, .1,.1,.1,.3)	--HORIZONTAL|VERTICAL


-- use '/print GetMouseFocus():GetName()' to get frame name
local pool, frames = {}, {
	ActionBarFogBGFrame = true, -- AuctionBar BG
	FriendsFrame = true,
	CharacterFrame = true,
	GossipFrame = true,
	TaxiFrame = true,
	SpellBookFrame = true,
	ClassTrainerFrame = true,
	MerchantFrame = true,
	MailFrame = true,
	PlayerTalentFrame = true,
	PVPFrame = true,
	PVPTeamDetails = true,
	QuestFrame = true,
	QuestLogFrame = true,
	LGFParentFrame = true,
	AchievementFrame = true,
	ChatFrameEditBox = true,
	WorldMapFrame = true, 
	LootFrame = true,
	StaticPopup1 = true,
	DressUpFrame = true,
	VideoOptionsFrame = true,
	GameMenuFrame = true,
	AudioOptionsFrame = true,
	KeyBindingFrame = true,
	MacroFrame = true,
	InterfaceOptionsFrame = true,
	ChatFrame1 = {0,0,2,-5},
	ChatFrame2 = {0,0,2,-5},
}

for frame, position in pairs(frames) do
	if getglobal(frame) then
		local f = CreateFrame'PlayerModel'
		f:SetParent(frame)
		f:SetFrameStrata'BACKGROUND'
		if type(position) == 'table' then
			f:SetPoint('TOPLEFT', frame, position[1], position[2])
			f:SetPoint('BOTTOMRIGHT', frame, position[3], position[4])
		else
			f:SetAllPoints(frame)
		end
		f:SetScript('OnShow', function(self) self:SetModel(Fog) end)
		f:SetModel(Fog)
		--f:SetPosition(0,1,0.8)
		f:Show()
		table.insert(pool,f)
	end
end


--[[local zone = {
	['阿拉希盆地'] = {0,1,0.2},
	['奥特兰克山谷'] = {0,1.5,3},
}

ActionBarFogBGFrame:RegisterEvent'PLAYER_ENTERING_WORLD'
ActionBarFogBGFrame:SetScript('OnEvent', function()
	local coords = zone[GetRealZoneText()]
	for i = 1, #pool do
		local f = pool[i]
		if not f then break end
		
		f:SetPosition(unpack(coords or {0,1,0.8}))
	end
end)]]

local function Hook(frame, script, func)
	if frame:GetScript(script) then
		frame:HookScript(script, func)
	else
		frame:SetScript(script, func)
	end
end

Hook(WorldMapFrame, 'OnHide', function()
	for i = 1, #pool do
		local f = pool[i]
		
		f:SetModel(Fog)
		f:Show()
	end
end)

